/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.shop.GoodsLimit
 *  fire.pb.shop.SGoods
 *  fire.pb.shop.SQueryLimit
 *  fire.pb.util.DateValidate
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.NumberAndTime
 *  xbean.Pod
 *  xbean.RoleBuyGoodsLimit
 *  xbean.RoleSaleGoodsLimit
 *  xtable.Rolebuygoodslimits
 *  xtable.Rolesalegoodslimits
 */
package fire.pb.shop.srv.limit;

import fire.pb.shop.GoodsLimit;
import fire.pb.shop.SGoods;
import fire.pb.shop.SQueryLimit;
import fire.pb.util.DateValidate;
import java.util.ArrayList;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.NumberAndTime;
import xbean.Pod;
import xbean.RoleBuyGoodsLimit;
import xbean.RoleSaleGoodsLimit;
import xtable.Rolebuygoodslimits;
import xtable.Rolesalegoodslimits;

public class LimitManager {
    public static LimitManager getInstance() {
        return LimitBuySrvHolder.instance;
    }

    public boolean isBuyLimit(long roleid, SGoods goods, int buyNum, int extNum) {
        if (goods.limitType == 0) {
            return true;
        }
        int retBuyNum = this.retBuyNum(roleid, goods);
        if (retBuyNum == 0) {
            return true;
        }
        return retBuyNum + buyNum <= goods.limitNum + extNum;
    }

    public int retBuyNum(long roleid, SGoods goods) {
        long curr = System.currentTimeMillis();
        RoleBuyGoodsLimit buyGoodsLimit = Rolebuygoodslimits.get((Long)roleid);
        if (buyGoodsLimit == null) {
            return 0;
        }
        NumberAndTime bean = null;
        switch (goods.limitType) {
            case 1: {
                bean = (NumberAndTime)buyGoodsLimit.getDaylimit().get(goods.getId());
                if (bean == null || !DateValidate.inTheSameDay((long)curr, (long)bean.getTime())) break;
                return bean.getNumber();
            }
            case 2: {
                bean = (NumberAndTime)buyGoodsLimit.getWeeklimit().get(goods.getId());
                if (bean == null || !DateValidate.inTheSameWeek((long)curr, (long)bean.getTime())) break;
                return bean.getNumber();
            }
            case 3: {
                bean = (NumberAndTime)buyGoodsLimit.getMonthlimit().get(goods.getId());
                if (bean == null || !DateValidate.inTheSameMonth((long)curr, (long)bean.getTime())) break;
                return bean.getNumber();
            }
        }
        return 0;
    }

    public int saveBuyLimit(long roleid, SGoods goods, int buyNum) {
        if (goods.limitType == 0) {
            return -1;
        }
        RoleBuyGoodsLimit buyGoodsLimit = Rolebuygoodslimits.get((Long)roleid);
        if (buyGoodsLimit == null) {
            buyGoodsLimit = Pod.newRoleBuyGoodsLimit();
            Rolebuygoodslimits.insert((Long)roleid, (RoleBuyGoodsLimit)buyGoodsLimit);
        }
        long curr = System.currentTimeMillis();
        NumberAndTime bean = null;
        int newNum = 0;
        switch (goods.limitType) {
            case 1: {
                bean = (NumberAndTime)buyGoodsLimit.getDaylimit().get(goods.getId());
                if (bean == null) {
                    bean = Pod.newNumberAndTime();
                    buyGoodsLimit.getDaylimit().put(goods.getId(), bean);
                }
                if (DateValidate.inTheSameDay((long)curr, (long)bean.getTime())) {
                    int number = bean.getNumber();
                    newNum = number + buyNum;
                    bean.setNumber(newNum);
                } else {
                    newNum = buyNum;
                    bean.setNumber(newNum);
                }
                bean.setTime(curr);
                break;
            }
            case 2: {
                bean = (NumberAndTime)buyGoodsLimit.getWeeklimit().get(goods.getId());
                if (bean == null) {
                    bean = Pod.newNumberAndTime();
                    buyGoodsLimit.getWeeklimit().put(goods.getId(), bean);
                }
                if (DateValidate.inTheSameWeek((long)curr, (long)bean.getTime())) {
                    int number = bean.getNumber();
                    newNum = number + buyNum;
                    bean.setNumber(newNum);
                } else {
                    newNum = buyNum;
                    bean.setNumber(newNum);
                }
                bean.setTime(curr);
                break;
            }
            case 3: {
                bean = (NumberAndTime)buyGoodsLimit.getMonthlimit().get(goods.getId());
                if (bean == null) {
                    bean = Pod.newNumberAndTime();
                    buyGoodsLimit.getMonthlimit().put(goods.getId(), bean);
                }
                if (DateValidate.inTheSameMonth((long)curr, (long)bean.getTime())) {
                    int number = bean.getNumber();
                    newNum = number + buyNum;
                    bean.setNumber(newNum);
                } else {
                    newNum = buyNum;
                    bean.setNumber(newNum);
                }
                bean.setTime(curr);
            }
        }
        this.postNofy(1, roleid, goods.id, newNum);
        return newNum;
    }

    public boolean isSaleLimit(long roleid, SGoods goods, int saleNum) {
        if (goods.limitType == 0) {
            return true;
        }
        int retSaleNum = this.retSaleNum(roleid, goods);
        if (retSaleNum == 0) {
            return true;
        }
        return retSaleNum + saleNum <= goods.limitSaleNum;
    }

    public int retSaleNum(long roleid, SGoods goods) {
        long curr = System.currentTimeMillis();
        RoleSaleGoodsLimit saleGoodsLimit = Rolesalegoodslimits.get((Long)roleid);
        if (saleGoodsLimit == null) {
            return 0;
        }
        NumberAndTime bean = null;
        switch (goods.limitType) {
            case 1: {
                bean = (NumberAndTime)saleGoodsLimit.getDaylimit().get(goods.getId());
                if (bean == null || !DateValidate.inTheSameDay((long)curr, (long)bean.getTime())) break;
                return bean.getNumber();
            }
            case 2: {
                bean = (NumberAndTime)saleGoodsLimit.getWeeklimit().get(goods.getId());
                if (bean == null || !DateValidate.inTheSameWeek((long)curr, (long)bean.getTime())) break;
                return bean.getNumber();
            }
            case 3: {
                bean = (NumberAndTime)saleGoodsLimit.getMonthlimit().get(goods.getId());
                if (bean == null || !DateValidate.inTheSameMonth((long)curr, (long)bean.getTime())) break;
                return bean.getNumber();
            }
        }
        return 0;
    }

    public int saveSaleLimit(long roleid, SGoods goods, int saleNum) {
        if (goods.limitType == 0) {
            return -1;
        }
        RoleSaleGoodsLimit saleGoodsLimit = Rolesalegoodslimits.get((Long)roleid);
        if (saleGoodsLimit == null) {
            saleGoodsLimit = Pod.newRoleSaleGoodsLimit();
            Rolesalegoodslimits.insert((Long)roleid, (RoleSaleGoodsLimit)saleGoodsLimit);
        }
        long curr = System.currentTimeMillis();
        NumberAndTime bean = null;
        int newNum = 0;
        switch (goods.limitType) {
            case 1: {
                bean = (NumberAndTime)saleGoodsLimit.getDaylimit().get(goods.getId());
                if (bean == null) {
                    bean = Pod.newNumberAndTime();
                    saleGoodsLimit.getDaylimit().put(goods.getId(), bean);
                }
                if (DateValidate.inTheSameDay((long)curr, (long)bean.getTime())) {
                    int number = bean.getNumber();
                    newNum = number + saleNum;
                    bean.setNumber(newNum);
                } else {
                    newNum = saleNum;
                    bean.setNumber(newNum);
                }
                bean.setTime(curr);
                break;
            }
            case 2: {
                bean = (NumberAndTime)saleGoodsLimit.getWeeklimit().get(goods.getId());
                if (bean == null) {
                    bean = Pod.newNumberAndTime();
                    saleGoodsLimit.getWeeklimit().put(goods.getId(), bean);
                }
                if (DateValidate.inTheSameWeek((long)curr, (long)bean.getTime())) {
                    int number = bean.getNumber();
                    newNum = number + saleNum;
                    bean.setNumber(newNum);
                } else {
                    newNum = saleNum;
                    bean.setNumber(newNum);
                }
                bean.setTime(curr);
                break;
            }
            case 3: {
                bean = (NumberAndTime)saleGoodsLimit.getMonthlimit().get(goods.getId());
                if (bean == null) {
                    bean = Pod.newNumberAndTime();
                    saleGoodsLimit.getMonthlimit().put(goods.getId(), bean);
                }
                if (DateValidate.inTheSameMonth((long)curr, (long)bean.getTime())) {
                    int number = bean.getNumber();
                    newNum = number + saleNum;
                    bean.setNumber(newNum);
                } else {
                    newNum = saleNum;
                    bean.setNumber(newNum);
                }
                bean.setTime(curr);
            }
        }
        this.postNofy(2, roleid, goods.id, newNum);
        return newNum;
    }

    public void postNofy(int type, long roldId, int goodsId, int number) {
        GoodsLimit goodsLimit = new GoodsLimit(goodsId, number);
        ArrayList<GoodsLimit> goodsLimits = new ArrayList<GoodsLimit>(1);
        goodsLimits.add(goodsLimit);
        SQueryLimit squeryLimit = new SQueryLimit(type, goodsLimits);
        Procedure.psendWhileCommit((long)roldId, (Protocol)squeryLimit);
    }

    public static class LimitBuySrvHolder {
        static LimitManager instance = new LimitManager();
    }
}

